"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Rx_1 = require('rxjs/Rx');
var ObservableArray = (function (_super) {
    __extends(ObservableArray, _super);
    function ObservableArray(array) {
        _super.call(this);
        this._array = array || [];
    }
    Object.defineProperty(ObservableArray.prototype, "array", {
        get: function () {
            return this._array;
        },
        set: function (value) {
            this._array = value;
            this.next(this._array);
        },
        enumerable: true,
        configurable: true
    });
    ObservableArray.prototype.push = function (item) {
        this._array.push(item);
        this.next(this._array);
    };
    ObservableArray.prototype.remove = function (valueOrPredicate) {
        var predicate = typeof valueOrPredicate === 'function'
            ? valueOrPredicate
            : function (value) { return value === valueOrPredicate; };
        var removedValues = [];
        for (var i = 0; i < this._array.length; i++) {
            var value = this._array[i];
            if (predicate(value)) {
                removedValues.push(value);
                this._array.splice(i, 1);
                i--;
            }
        }
        this.next(this._array);
        return removedValues;
    };
    return ObservableArray;
}(Rx_1.Subject));
exports.ObservableArray = ObservableArray;
//# sourceMappingURL=ObservableArray.js.map