import { Http, Response } from '@angular/http';
import { Injectable, EventEmitter, Output } from '@angular/core';
import {
    INgDataGridOperation, INgDataGridData,
    IPaging, INgDataGridDataConfig,
    INgDataGridPagingConfig, INgDataGridServerConfig,
    INgDataGridChangeConfig,
    INgDataGridConfig
} from './ng-datagrid.interfaces';
import { NgDataGrid } from './ng-datagrid.service';

@Injectable()
export class DataFactory {
    constructor(private http: Http) {

    }

    createInMemoryProcess<T>(config: INgDataGridConfig<T>): NgDataGrid<T> {
        return new NgDataGrid<T>(config);
    }

    createDataWithPaging<T>(config: INgDataGridPagingConfig<T>): NgDataGridPaging<T> {
        return new NgDataGridPaging<T>(config.items, config.pageSize);
    }

    createServerProcess<T>(options: INgDataGridServerConfig): NgDataGridServer<T> {
        return new NgDataGridServer<T>(options.pageSize, options.url,
                                       options.showProcessing,
                                       options.deferRendering,
                                       this.http);
    }
}