import { ObservableArray } from './ObservableArray';
import { Observable } from 'rxjs/Rx';

export interface INgDataGridOperation<T> {
    getData(config: INgDataGridChangeConfig<T>): Observable<T[]>;
}

export interface INgDataGridChangeConfig<T> {
    searchValue?: T;
    pageSize?: number;
    pagingNumber?: number;
}

export interface INgDataGridDataConfig<T> {
    items?: Array<T>;
    searchValue?: T;
}

export interface INgDataGridPagingConfig<T> {
    items?: Array<T>;
    pageSize?: number;
}

export interface INgDataGridServerConfig {
    url: string;

    pageSize?: number;

    isServerProcessing?: boolean;
    deferRendering?: boolean;
    showProcessing?: boolean;
}

export interface INgDataGridData<T> {
    searchValue: T;

    totalRows?: number;
    totalFilteredRows?: number;

    items: ObservableArray<T>;

    itemsFiltered?: Array<T>;
    itemsOnCurrentPage?: Array<T>;

    isProcessing?: boolean;
}


export interface IPaging {
    pageStart: number;
    pageEnd: number;
    currentPageIndex: number;
}
